"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _index = require("../styles/index");

var _overrides = require("../helpers/overrides");

var _buttonDock = require("../button-dock");

var _button = require("../button");

var _icon = require("../icon");

var _styledComponents = require("./styled-components");

var _constants = require("./constants");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function renderArtwork(artwork) {
  if ( /*#__PURE__*/(0, _react.isValidElement)(artwork)) {
    return artwork;
  } else if (typeof artwork === 'function') {
    var ArtworkComponent = artwork;
    return /*#__PURE__*/_react.default.createElement(ArtworkComponent, null);
  }

  return null;
}

var DefaultDismissButton = function DefaultDismissButton(props) {
  var overrides = {
    BaseButton: {
      style: {
        position: 'absolute',
        top: '16px',
        right: '8px',
        // this will be tokenized in the future
        backgroundColor: 'rgba(255, 255, 255, 0.6)',
        zIndex: 1
      }
    }
  };
  return /*#__PURE__*/_react.default.createElement(_button.Button, _extends({
    kind: _button.KIND.secondary,
    shape: _button.SHAPE.circle,
    overrides: overrides
  }, props), /*#__PURE__*/_react.default.createElement(_icon.Delete, {
    size: 36
  }));
};

var DefaultButtonDock = function DefaultButtonDock(props) {
  var _useStyletron = (0, _index.useStyletron)(),
      _useStyletron2 = _slicedToArray(_useStyletron, 2),
      theme = _useStyletron2[1];

  var overrides = {
    Root: {
      style: {
        paddingRight: theme.sizing.scale800,
        paddingLeft: theme.sizing.scale800,
        marginBottom: theme.sizing.scale800
      }
    }
  };
  return /*#__PURE__*/_react.default.createElement(_buttonDock.ButtonDock, _extends({
    overrides: overrides
  }, props));
};

var Dialog = function Dialog(_ref) {
  var artwork = _ref.artwork,
      buttonDock = _ref.buttonDock,
      children = _ref.children,
      handleDismiss = _ref.handleDismiss,
      _ref$showDismissButto = _ref.showDismissButton,
      showDismissButton = _ref$showDismissButto === void 0 ? true : _ref$showDismissButto,
      _ref$hasOverlay = _ref.hasOverlay,
      hasOverlay = _ref$hasOverlay === void 0 ? true : _ref$hasOverlay,
      heading = _ref.heading,
      isOpen = _ref.isOpen,
      _ref$overrides = _ref.overrides,
      overrides = _ref$overrides === void 0 ? {} : _ref$overrides,
      _ref$placement = _ref.placement,
      placement = _ref$placement === void 0 ? _constants.PLACEMENT.center : _ref$placement,
      _ref$numHeadingLines = _ref.numHeadingLines,
      numHeadingLines = _ref$numHeadingLines === void 0 ? 2 : _ref$numHeadingLines,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? _constants.SIZE.xSmall : _ref$size;

  var _getOverrides = (0, _overrides.getOverrides)(overrides.Root, _styledComponents.StyledRoot),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      Root = _getOverrides2[0],
      rootProps = _getOverrides2[1];

  var _getOverrides3 = (0, _overrides.getOverrides)(overrides.ScrollContainer, _styledComponents.StyledScrollContainer),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      ScrollContainer = _getOverrides4[0],
      scrollContainerProps = _getOverrides4[1];

  var _getOverrides5 = (0, _overrides.getOverrides)(overrides.Heading, _styledComponents.StyledHeading),
      _getOverrides6 = _slicedToArray(_getOverrides5, 2),
      Heading = _getOverrides6[0],
      headingProps = _getOverrides6[1];

  var _getOverrides7 = (0, _overrides.getOverrides)(overrides.Body, _styledComponents.StyledBody),
      _getOverrides8 = _slicedToArray(_getOverrides7, 2),
      Body = _getOverrides8[0],
      bodyProps = _getOverrides8[1];

  var _getOverrides9 = (0, _overrides.getOverrides)(overrides.ButtonDock, DefaultButtonDock),
      _getOverrides10 = _slicedToArray(_getOverrides9, 2),
      ButtonDock = _getOverrides10[0],
      buttonDockProps = _getOverrides10[1];

  var _getOverrides11 = (0, _overrides.getOverrides)(overrides.DismissButton, DefaultDismissButton),
      _getOverrides12 = _slicedToArray(_getOverrides11, 2),
      DismissButton = _getOverrides12[0],
      dismissButtonProps = _getOverrides12[1];

  var dialogRef = _react.default.useRef(null);

  _react.default.useEffect(function () {
    if (isOpen) {
      if (hasOverlay) {
        dialogRef.current.showModal();
      } else {
        dialogRef.current.show();
      }
    } else {
      dialogRef.current.close();
    }
  }, [isOpen, hasOverlay]);

  function handleOutsideClick(e) {
    if (!dialogRef.current.contains(e.target) || e.target.nodeName === 'DIALOG') {
      handleDismiss();
    }
  }

  function handleEscapeKey(e) {
    if (e.key === 'Escape') {
      handleDismiss();
    }
  }

  _react.default.useEffect(function () {
    if (isOpen) {
      // No delay, just pushing it to the end of the call stack so that the
      // Dialog doesn't close immediately after opening via click event
      var timer = setTimeout(function () {
        document.addEventListener('click', handleOutsideClick);
      }, 0);
      document.addEventListener('keydown', handleEscapeKey);
      return function () {
        clearTimeout(timer);
        document.removeEventListener('click', handleOutsideClick);
        document.removeEventListener('keydown', handleEscapeKey);
      };
    } else {
      document.removeEventListener('click', handleOutsideClick);
      document.removeEventListener('keydown', handleEscapeKey);
    }
  }, [isOpen]);

  return /*#__PURE__*/_react.default.createElement(Root, _extends({
    ref: dialogRef,
    $isOpen: isOpen,
    $size: size,
    $placement: placement
  }, rootProps), handleDismiss && showDismissButton && /*#__PURE__*/_react.default.createElement(DismissButton, _extends({
    onClick: function onClick() {
      return handleDismiss();
    }
  }, dismissButtonProps)), /*#__PURE__*/_react.default.createElement(ScrollContainer, _extends({}, scrollContainerProps, {
    tabIndex: 0
  }), renderArtwork(artwork), /*#__PURE__*/_react.default.createElement(Heading, _extends({
    $numHeadingLines: numHeadingLines
  }, headingProps), heading), /*#__PURE__*/_react.default.createElement(Body, bodyProps, children)), buttonDock && /*#__PURE__*/_react.default.createElement(ButtonDock, _extends({}, buttonDock, buttonDockProps)));
};

var _default = Dialog;
exports.default = _default;