function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import React, { isValidElement } from 'react';
import { useStyletron } from '../styles/index';
import { getOverrides } from '../helpers/overrides';
import { ButtonDock } from '../button-dock';
import { Button, KIND, SHAPE } from '../button';
import { Delete } from '../icon';
import { StyledHeading, StyledBody, StyledRoot, StyledScrollContainer } from './styled-components';
import { PLACEMENT, SIZE } from './constants';

function renderArtwork(artwork) {
  if ( /*#__PURE__*/isValidElement(artwork)) {
    return artwork;
  } else if (typeof artwork === 'function') {
    var ArtworkComponent = artwork;
    return /*#__PURE__*/React.createElement(ArtworkComponent, null);
  }

  return null;
}

var DefaultDismissButton = function DefaultDismissButton(props) {
  var overrides = {
    BaseButton: {
      style: {
        position: 'absolute',
        top: '16px',
        right: '8px',
        // this will be tokenized in the future
        backgroundColor: 'rgba(255, 255, 255, 0.6)',
        zIndex: 1
      }
    }
  };
  return /*#__PURE__*/React.createElement(Button, _extends({
    kind: KIND.secondary,
    shape: SHAPE.circle,
    overrides: overrides
  }, props), /*#__PURE__*/React.createElement(Delete, {
    size: 36
  }));
};

var DefaultButtonDock = function DefaultButtonDock(props) {
  var _useStyletron = useStyletron(),
      _useStyletron2 = _slicedToArray(_useStyletron, 2),
      theme = _useStyletron2[1];

  var overrides = {
    Root: {
      style: {
        paddingRight: theme.sizing.scale800,
        paddingLeft: theme.sizing.scale800,
        marginBottom: theme.sizing.scale800
      }
    }
  };
  return /*#__PURE__*/React.createElement(ButtonDock, _extends({
    overrides: overrides
  }, props));
};

var Dialog = function Dialog(_ref) {
  var artwork = _ref.artwork,
      buttonDock = _ref.buttonDock,
      children = _ref.children,
      handleDismiss = _ref.handleDismiss,
      _ref$showDismissButto = _ref.showDismissButton,
      showDismissButton = _ref$showDismissButto === void 0 ? true : _ref$showDismissButto,
      _ref$hasOverlay = _ref.hasOverlay,
      hasOverlay = _ref$hasOverlay === void 0 ? true : _ref$hasOverlay,
      heading = _ref.heading,
      isOpen = _ref.isOpen,
      _ref$overrides = _ref.overrides,
      overrides = _ref$overrides === void 0 ? {} : _ref$overrides,
      _ref$placement = _ref.placement,
      placement = _ref$placement === void 0 ? PLACEMENT.center : _ref$placement,
      _ref$numHeadingLines = _ref.numHeadingLines,
      numHeadingLines = _ref$numHeadingLines === void 0 ? 2 : _ref$numHeadingLines,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? SIZE.xSmall : _ref$size;

  var _getOverrides = getOverrides(overrides.Root, StyledRoot),
      _getOverrides2 = _slicedToArray(_getOverrides, 2),
      Root = _getOverrides2[0],
      rootProps = _getOverrides2[1];

  var _getOverrides3 = getOverrides(overrides.ScrollContainer, StyledScrollContainer),
      _getOverrides4 = _slicedToArray(_getOverrides3, 2),
      ScrollContainer = _getOverrides4[0],
      scrollContainerProps = _getOverrides4[1];

  var _getOverrides5 = getOverrides(overrides.Heading, StyledHeading),
      _getOverrides6 = _slicedToArray(_getOverrides5, 2),
      Heading = _getOverrides6[0],
      headingProps = _getOverrides6[1];

  var _getOverrides7 = getOverrides(overrides.Body, StyledBody),
      _getOverrides8 = _slicedToArray(_getOverrides7, 2),
      Body = _getOverrides8[0],
      bodyProps = _getOverrides8[1];

  var _getOverrides9 = getOverrides(overrides.ButtonDock, DefaultButtonDock),
      _getOverrides10 = _slicedToArray(_getOverrides9, 2),
      ButtonDock = _getOverrides10[0],
      buttonDockProps = _getOverrides10[1];

  var _getOverrides11 = getOverrides(overrides.DismissButton, DefaultDismissButton),
      _getOverrides12 = _slicedToArray(_getOverrides11, 2),
      DismissButton = _getOverrides12[0],
      dismissButtonProps = _getOverrides12[1];

  var dialogRef = React.useRef(null);
  React.useEffect(function () {
    if (isOpen) {
      if (hasOverlay) {
        dialogRef.current.showModal();
      } else {
        dialogRef.current.show();
      }
    } else {
      dialogRef.current.close();
    }
  }, [isOpen, hasOverlay]);

  function handleOutsideClick(e) {
    if (!dialogRef.current.contains(e.target) || e.target.nodeName === 'DIALOG') {
      handleDismiss();
    }
  }

  function handleEscapeKey(e) {
    if (e.key === 'Escape') {
      handleDismiss();
    }
  }

  React.useEffect(function () {
    if (isOpen) {
      // No delay, just pushing it to the end of the call stack so that the
      // Dialog doesn't close immediately after opening via click event
      var timer = setTimeout(function () {
        document.addEventListener('click', handleOutsideClick);
      }, 0);
      document.addEventListener('keydown', handleEscapeKey);
      return function () {
        clearTimeout(timer);
        document.removeEventListener('click', handleOutsideClick);
        document.removeEventListener('keydown', handleEscapeKey);
      };
    } else {
      document.removeEventListener('click', handleOutsideClick);
      document.removeEventListener('keydown', handleEscapeKey);
    }
  }, [isOpen]);
  return /*#__PURE__*/React.createElement(Root, _extends({
    ref: dialogRef,
    $isOpen: isOpen,
    $size: size,
    $placement: placement
  }, rootProps), handleDismiss && showDismissButton && /*#__PURE__*/React.createElement(DismissButton, _extends({
    onClick: function onClick() {
      return handleDismiss();
    }
  }, dismissButtonProps)), /*#__PURE__*/React.createElement(ScrollContainer, _extends({}, scrollContainerProps, {
    tabIndex: 0
  }), renderArtwork(artwork), /*#__PURE__*/React.createElement(Heading, _extends({
    $numHeadingLines: numHeadingLines
  }, headingProps), heading), /*#__PURE__*/React.createElement(Body, bodyProps, children)), buttonDock && /*#__PURE__*/React.createElement(ButtonDock, _extends({}, buttonDock, buttonDockProps)));
};

export default Dialog;