function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import { styled } from '../styles';
import { FILL } from './constants';
import { isIntrinsic, isFixed } from './utils';
export var StyledRoot = styled('div', function (_ref) {
  var $theme = _ref.$theme,
      _ref$$fill = _ref.$fill,
      $fill = _ref$$fill === void 0 ? FILL.intrinsic : _ref$$fill,
      _ref$$height = _ref.$height,
      $height = _ref$$height === void 0 ? 'fit-content' : _ref$$height,
      _ref$$width = _ref.$width,
      $width = _ref$$width === void 0 ? 'fit-content' : _ref$$width;
  var style = {
    backgroundColor: $theme.colors.backgroundTertiary,
    borderRadius: $theme.sizing.scale500,
    boxSizing: 'border-box',
    isolation: 'isolate',
    padding: $theme.sizing.scale100,
    position: 'relative',
    overflow: 'hidden',
    height: $height,
    width: $width,
    margin: $theme.sizing.scale100
  };

  if (isIntrinsic($fill)) {
    style['::-webkit-scrollbar'] = {
      display: 'none'
    };
    style['-ms-overflow-style'] = 'none';
    style.scrollbarWidth = 'none';
  }

  return style;
});
StyledRoot.displayName = "StyledRoot";
StyledRoot.displayName = 'StyledRoot';
export var StyledSegmentList = styled('div', function (_ref2) {
  var $theme = _ref2.$theme;
  var style = {
    backgroundColor: $theme.colors.backgroundTertiary,
    boxSizing: 'border-box',
    display: 'flex',
    height: '100%',
    justifyContent: 'space-evenly',
    position: 'relative',
    width: '100%',
    zIndex: -2,
    flexDirection: 'row',
    overflow: 'hidden',
    minHeight: '40px'
  };
  return style;
});
StyledSegmentList.displayName = "StyledSegmentList";
StyledSegmentList.displayName = 'StyledSegmentList';
export var StyledSegment = styled('button', function (_ref3) {
  var $theme = _ref3.$theme,
      _ref3$$fill = _ref3.$fill,
      $fill = _ref3$$fill === void 0 ? FILL.intrinsic : _ref3$$fill,
      _ref3$$focusVisible = _ref3.$focusVisible,
      $focusVisible = _ref3$$focusVisible === void 0 ? false : _ref3$$focusVisible,
      _ref3$$isActive = _ref3.$isActive,
      $isActive = _ref3$$isActive === void 0 ? false : _ref3$$isActive;
  var style = {
    cursor: 'pointer',
    position: 'relative',
    WebkitAppearance: 'none',
    marginLeft: '0',
    marginRight: '0',
    marginTop: '0',
    marginBottom: '0',
    boxSizing: 'border-box',
    display: 'grid',
    alignItems: 'center',
    paddingInline: $theme.sizing.scale500,
    paddingBlock: $theme.sizing.scale300,
    borderLeftWidth: 0,
    borderTopWidth: 0,
    borderRightWidth: 0,
    borderBottomWidth: 0,
    borderRadius: $theme.sizing.scale300,
    color: $theme.colors.contentPrimary,
    backgroundColor: 'transparent',
    flexGrow: 1,
    transitionProperty: 'box-shadow',
    transitionDuration: $theme.animation.timing200,
    transitionTimingFunction: $theme.animation.linearCurve,
    outline: 'none',
    outlineOffset: '-3px',
    justifyContent: 'center',
    overflow: 'hidden',
    ':hover': {
      boxShadow: $isActive ? 'none' : $theme.lighting.overlay100,
      zIndex: $isActive ? 'none' : -2
    },
    ':disabled': {
      cursor: 'not-allowed',
      color: $theme.colors.contentStateDisabled,
      ':hover': {
        boxShadow: 'none'
      }
    },
    ':disabled:hover': {
      background: 'none'
    }
  };

  if ($focusVisible) {
    style.outline = "3px solid ".concat($theme.colors.accent);
  }

  if (isFixed($fill)) {
    style.flexGrow = 1;
    style.flexBasis = 0;
  }

  return style;
});
StyledSegment.displayName = "StyledSegment";
StyledSegment.displayName = 'StyledSegment';
export var StyledArtworkContainer = styled('div', function () {
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  var style = {
    display: 'flex',
    height: '16px',
    width: '16px',
    alignItems: 'center'
  };
  return style;
});
StyledArtworkContainer.displayName = "StyledArtworkContainer";
StyledArtworkContainer.displayName = 'StyledArtworkContainer';
export var StyledActive = styled('div', function (_ref4) {
  var $theme = _ref4.$theme,
      _ref4$$length = _ref4.$length,
      $length = _ref4$$length === void 0 ? 0 : _ref4$$length,
      _ref4$$distance = _ref4.$distance,
      $distance = _ref4$$distance === void 0 ? 0 : _ref4$$distance,
      _ref4$$animate = _ref4.$animate,
      $animate = _ref4$$animate === void 0 ? false : _ref4$$animate;
  var style = {
    position: 'absolute',
    borderRadius: $theme.sizing.scale300,
    boxSizing: 'border-box',
    height: '100%',
    width: '100%',
    border: "".concat($theme.sizing.scale0, " solid ").concat($theme.colors.primary),
    backgroundColor: $theme.colors.backgroundPrimary,
    zIndex: -1
  };
  style.bottom = '0px';
  style.left = '0px';
  style.width = "".concat($length, "px");
  style.transform = "translateX(".concat($distance, "px)");

  if ($animate) {
    style.transitionProperty = 'all';
    style.transitionDuration = $theme.animation.timing400;
    style.transitionTimingFunction = $theme.animation.easeInOutQuinticCurve;
  }

  return style;
});
StyledActive.displayName = "StyledActive";
StyledActive.displayName = 'StyledActive';
export var StyledSegmentPanel = styled('div', function (_ref5) {
  var $theme = _ref5.$theme,
      _ref5$$pad = _ref5.$pad,
      $pad = _ref5$$pad === void 0 ? true : _ref5$$pad;
  var style = {
    flexGrow: 1,
    outline: 'none'
  };

  if ($pad) {
    style.paddingTop = $theme.sizing.scale600;
    style.paddingRight = $theme.sizing.scale600;
    style.paddingBottom = $theme.sizing.scale600;
    style.paddingLeft = $theme.sizing.scale600;
  }

  return style;
});
StyledSegmentPanel.displayName = "StyledSegmentPanel";
StyledSegmentPanel.displayName = 'StyledSegmentPanel';
export var StyledLabel = styled('div', function (_ref6) {
  var $theme = _ref6.$theme;

  var style = _objectSpread(_objectSpread({}, $theme.typography.LabelSmall), {}, {
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis',
    position: 'relative'
  });

  return style;
});
StyledLabel.displayName = "StyledLabel";
export var StyledDescription = styled('div', function (_ref7) {
  var $theme = _ref7.$theme;
  return _objectSpread(_objectSpread({}, $theme.typography.ParagraphXSmall), {}, {
    padding: 0,
    margin: 0,
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis',
    position: 'relative'
  });
});
StyledDescription.displayName = "StyledDescription";
export var StyledLabelBlock = styled('div', function (_ref8) {
  var $theme = _ref8.$theme;
  return {
    display: 'flex',
    gridGap: $theme.sizing.scale100,
    alignItems: 'center',
    position: 'relative',
    justifyContent: 'center',
    overflow: 'hidden'
  };
});
StyledLabelBlock.displayName = "StyledLabelBlock";
export var StyledBadge = styled('div', function (_ref9) {
  var $theme = _ref9.$theme;
  return _objectSpread(_objectSpread({}, $theme.typography.ParagraphXSmall), {}, {
    width: '16px',
    height: '16px',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    borderRadius: '50%',
    backgroundColor: $theme.colors.accent,
    color: $theme.colors.white
  });
});
StyledBadge.displayName = "StyledBadge";
export var StyledBadgeHint = styled('div', function (_ref10) {
  var $theme = _ref10.$theme;
  return {
    width: '8px',
    height: '8px',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    borderRadius: '50%',
    backgroundColor: $theme.colors.accent,
    color: $theme.colors.accent,
    alignSelf: 'start',
    marginLeft: '-2px'
  };
});
StyledBadgeHint.displayName = "StyledBadgeHint";